## org.eclipse.wst.server.core.util
Class ProjectModule

    java.lang.Object
      org.eclipse.wst.server.core.model.ModuleDelegate
          org.eclipse.wst.server.core.util.ProjectModule

    public abstract class ProjectModule

extends ModuleDelegate

A simple IModuleProject that maps a folder within a project (or the root of the project itself) to the module.

Since:
  1.0

Constructor Summary
`ProjectModule()` Create a new project module.
`ProjectModule(IProject project)` Create a new project module in the given project.

Method Summary
`boolean` `equals(java.lang.Object obj)`
`boolean` `exists()` Returns true if this module currently exists, and false if it has been deleted or moved and is no longer represented by this module.
`IModule[]` `getChildModules()` Returns the child modules of this module.
`java.lang.String` `getId()` Helper method - returns the module's id.
`java.lang.String` `getName()` Helper method - returns the module's name.
`IProject` `getProject()` Returns the project that the module is contained in.
`boolean` `isSingleRootStructure()` Returns `true` if this module has a simple structure based on a single root folder, and `false` otherwise.
`IModuleResource[]` `members()` Basic implementation of members() method.
`IStatus` `validate()` Validates this module instance.

Methods inherited from class org.eclipse.wst.server.core.model.ModuleDelegate
`getModule, initialize, initialize`

Methods inherited from class java.lang.Object
`getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ProjectModule

    public ProjectModule()

  Create a new project module.

### ProjectModule

    public ProjectModule(IProject project)

  Create a new project module in the given project.

  Parameters:
    `project` - the project containing the module

Method Detail

### getProject

    public IProject getProject()

  Returns the project that the module is contained in.

  Returns:
    the project that the module is contained in

### getId

    public java.lang.String getId()

  Helper method - returns the module's id.

  Returns:
    the module id

### validate

    public IStatus validate()

  Description copied from class: `ModuleDelegate`
  Validates this module instance. Subclasses should override and call super.validate() for basic validation.

  This method is called by the web server core framework. Clients should never call this method.

  Specified by:
    `validate` in class `ModuleDelegate`
  Returns:
    a status object with code `IStatus.OK` if this module is valid, otherwise a status object indicating what is wrong with it
  See Also:
    `ModuleDelegate.validate()`

### getName

    public java.lang.String getName()

  Helper method - returns the module's name.

  Returns:
    the module name

### exists

    public boolean exists()

  Returns true if this module currently exists, and false if it has been deleted or moved and is no longer represented by this module.

  Returns:
    boolean

### equals

    public boolean equals(java.lang.Object obj)

  Overrides:
    `equals` in class `java.lang.Object`
  See Also:
    `Object.equals(Object)`

### getChildModules

    public IModule[] getChildModules()

  Returns the child modules of this module.

  Specified by:
    `getChildModules` in class `ModuleDelegate`
  Returns:
    an array of child modules

### isSingleRootStructure

    public boolean isSingleRootStructure()

  Returns `true` if this module has a simple structure based on a single root folder, and `false` otherwise.

  In a single root structure, all files that are contained within the root folder are part of the module, and are already in the correct module structure. No module resources exist outside of this single folder.

  Returns:
    `true` if this module has a single root structure, and `false` otherwise

### members

    public IModuleResource[] members()
                              throws CoreException

  Basic implementation of members() method. Assumes that the entire project should be published to a server.

  Specified by:
    `members` in class `ModuleDelegate`
  Returns:
    a possibly empty array containing the module resources
  Throws:
    `CoreException` - thrown if there is a problem getting the members
  See Also:
    `ModuleDelegate.members()`